require("fizz")

require("fizz")
require("states")
require("player")

fizz.gravity = 500

-- give us some stuff to play with
function love.load()
  map =
  {
    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
    1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 
    1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 
    1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 1, 
    1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 
    1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 
    1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 
    1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 
    1, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 
    1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 
    1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 
    1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 
    1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 1, 1, 1, 1, 0, 0, 1, 
    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 1, 
    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  }

  maph = 16
  mapw = #map/maph
  
  love.window.setMode((mapw - 1)*16, (maph - 1)*16)

  -- create shapes and tile sprites
  for x = 0, mapw - 1 do
    for y = 0, maph - 1 do
      local i = map[y*mapw + x + 1]
      if i == 1 then
        local wx, wy = x*16, y*16
        fizz.addStatic('rect', wx, wy, 16, 16)
      end
    end
  end

  player = Player:create(32, 16*4)
  
  facing = 1
  tilesheet = love.graphics.newImage("player.png")
  quads = {}
  local w, h = tilesheet:getDimensions()
  for y = 1, 4 do
    for x = 1, 4 do
      local i = (y - 1)*4 + x
      assert(i >= 1 and i <= 16)
      quads[i] = love.graphics.newQuad((x - 1)*16, (y - 1)*16, 16, 16, w, h)
    end
  end

  animations =
  {
    standing = { start = 1, frames = 2, rate = 0.15 },
    running = { start = 3, frames = 6, rate = 0.1 },
    jumping = { start = 9, frames = 4, rate = 0.1 },
    falling = { start = 13, frames = 2, rate = 0.15 }
  }
end

accum = 0
step = 0.016

-- nothing too heavy
function love.update(dt)
  -- update the simulation
  accum = accum + dt
  while accum >= step do
    fizz.update(step)
    player:update(step)
    accum = accum - step
  end
end

function drawObject(v, r, g, b)
  local lg = love.graphics
  if v.shape == 'rect' then
    local x, y, w, h = v.x, v.y, v.hw, v.hh
    lg.setColor(r, g, b, 255)
    lg.rectangle("fill", x - w, y - h, w * 2, h * 2)
  elseif v.shape == 'circle' then
    local x, y, radius = v.x, v.y, v.r
    lg.setColor(r, g, b, 255)
    lg.circle("fill", x, y, radius, 32)
  elseif v.shape == 'line' then
    local x, y, x2, y2 = v.x, v.y, v.x2, v.y2
    lg.setColor(r, g, b, 255)
    lg.line(x, y, x2, y2)
  end
end

function love.draw()
  local lg = love.graphics
  for i, v in ipairs(fizz.statics) do
    drawObject(v, 127, 127, 127)
  end

  -- sync player direction
  local x, y = player:getPosition()
  local xm, ym = player:getMovement()
  if xm ~= 0 then
    facing = xm
  end
  if facing < 0 then
    x = x + 16
  end
  -- sync player animation
  local a = animations[player.state]
  local frame = math.floor(player.elapsed/a.rate)
  frame = frame%(a.frames)
  frame = frame + a.start
  lg.draw(tilesheet, quads[frame], x - 8, y - 8, 0, facing, 1)

  lg.setColor(255, 255, 255, 255)
  love.graphics.print("state: " .. player.state, 0, 0)
  love.graphics.print("elapsed: " .. player.elapsed, 0, 15)
end