states = {}

states.standing = {}

function states.standing:message(agent, msg)
  if msg == "fall" then
    agent:setState("falling")
  elseif msg == "jump" then
    agent:setState("jumping")
  elseif msg == "move" then
    agent:setState("running")
  end
end

states.running = {}

function states.running:update(agent, dt)
  local xv, yv = agent:getVelocity()
  local xm, ym = agent:getMovement()
  xv = xv + 100*xm
  agent:setVelocity(xv, yv)
end
function states.running:message(agent, msg)
  if msg == "fall" then
    agent:setState("falling")
  elseif msg == "jump" then
    agent:setState("jumping")
  elseif msg == "stop" then
    agent:setState("standing")
  end
end

states.falling = {}

function states.falling:update(agent, dt)
  local xv, yv = agent:getVelocity()
  local xm, ym = agent:getMovement()
  xv = xv + 2*xm
  agent:setVelocity(xv, yv)
end
function states.falling:message(agent, msg)
  if msg == "hitground" then
    local xm, ym = agent:getMovement()
    if xm == 0 then
      agent:setState("standing")
    else
      agent:setState("running")
    end
  end
end

states.jumping = {}

function states.jumping:update(agent, dt)
  local xv, yv = agent:getVelocity()
  local xm, ym = agent:getMovement()
  local jumptime = 0.25
  if agent.elapsed > jumptime then
    agent:setState("falling")
    return
  end
  if ym >= 0 then
    agent:setState("falling")
    return
  end
  local r = 1 - agent.elapsed/jumptime
  xv = xv + 7.5*xm
  yv = yv - 40*r
  agent:setVelocity(xv, yv)
end
function states.jumping:message(agent, msg)
  if msg == "hitroof" then
    agent:setState("falling")
  elseif msg == "hitground" then
    local xm, ym = agent:getMovement()
    if xm == 0 then
      agent:setState("standing")
    else
      agent:setState("running")
    end
  end
end